/*

Siesta 5.0.0
Copyright(c) 2009-2018 Bryntum AB
https://bryntum.com/contact
https://bryntum.com/products/siesta/license

*/
Role('Siesta.Launcher.Role.CanProcessArguments', {

    methods : {

        processArguments : function (args) {
            var options     = {}
            var argv        = []

            var currentOption

            var addOption   = function (option, value) {
                if (options.hasOwnProperty(option)) {
                    var prevValue   = options[ option ]

                    if (!(prevValue instanceof Array)) options[ option ] = [ prevValue ]

                    options[ option ].push(value)

                } else
                    options[ option ] = value

                currentOption = null
            }

            for (var i = 0; i < args.length; i++) {
                var arg     = args[ i ]

                var match   = /^\s*--([\w_-]+)(?=\=(.*)|$)/.exec(arg)

                // we get a switch like, --option or --option=value
                if (match) {
                    // dealing with current state first
                    // option w/o values get `new Boolean(true)` as value
                    if (currentOption) addOption(currentOption, new Boolean(true))

                    // now processing a new match
                    if (match[ 2 ] != undefined)
                        addOption(match[ 1 ], match[ 2 ])
                    else
                        currentOption = match[ 1 ]

                } else
                    if (currentOption)
                        addOption(currentOption, arg)
                    else
                        argv.push(arg)
            }

            // option w/o values get `new Boolean(true)` as value
            if (currentOption) addOption(currentOption, new Boolean(true))

            return {
                options     : options,
                argv        : argv
            }
        }
    }
    // eof methods
})
